<template>
	<div class="task-builder">

		<va-button v-if="!generated" text="Сгенерировать задание" @click.native="generate" />


		<slide-y-down-transition :duration="800" :group="true">

				<div class="task-card" v-if="selected.topic" :key="1">
					<div class="task-card__title">Тематика</div>
					<div class="task-card__subtitle">Постарайся придерживаться выбранной тематики. Контент и графику прикрепили.</div>

					<div class="task-card__topic">
						<emoji :emoji="selected.topic.emoji" />
						<div class="task-card__topic__title">{{ selected.topic.title }}</div>
						<div class="task-card__topic__text">{{ selected.topic.text }}</div>
						<a target="_blank" v-if="selected.topic.content" :href="selected.topic.content" class="task-card__topic__link">Контент</a>
						<a target="_blank" v-if="selected.topic.photos" :href="selected.topic.photos" class="task-card__topic__link">Фотографии</a>
						<a target="_blank" v-if="selected.topic.icons" :href="selected.topic.icons" class="task-card__topic__link">Иконки</a>
					</div>
				</div>

				<div class="task-card" v-if="selected.colors" :key="2">
					<div class="task-card__title">Цветовая гамма</div>
					<div class="task-card__subtitle">Используй в дизайне эти цвета. Кликай на них, чтобы скопировать.</div>
					<div class="task-card__colors">
						<button class="copy-btn" :data-clipboard-text="c" v-for="(c,i) in selected.colors" :key="i" :style="{backgroundColor: c}"><span>{{ c }}</span></button>
					</div>
				</div>

				<div class="task-card" v-if="selected.fonts" :key="3">
					<div class="task-card__title">Шрифтовая пара</div>
					<div class="task-card__subtitle">Подключи эти шрифты к проекту. Можешь скачать по ссылкам.</div>

					<div class="task-card__font" v-for="(f,i) in selected.fonts" :key="i">
						<div class="task-card__font__letters" :style="{fontFamily: f}">Aa</div>
						<div class="task-card__font__name">{{ f }}</div>
						<div class="task-card__font__type">{{ i == 0 ? 'Для заголовков' : 'Для текста' }}</div>
						<a :href="`https://fonts.google.com/specimen/${f.replaceAll(' ', '+')}`" target="_blank">Скачать</a>
					</div>

				</div>

		</slide-y-down-transition>

	</div>
</template>

<script>
import {SlideYDownTransition} from 'vue2-transitions';
import ClipboardJS from "clipboard";
import fonts from "google-fonts";

export default {
	components: {
		SlideYDownTransition
	},
	data() {
		return {
			colors: require('~/assets/content/tasks/colors.json'),
			fonts: require('~/assets/content/tasks/fonts.json'),
			topics: require('~/assets/content/tasks/topics.json'),

			generated: false,
			selected: {
				colors: null,
				fonts: null
			}
		}
	},

	computed: {
		predefined() {
			var variants = this.$route.query.v || false;
			if (variants) {
				var v = variants.split(',');

				return {
					topic: 	v[0] ? (this.topics[v[0] - 1] 	|| false) : false,
					colors: v[1] ? (this.colors[v[1] - 1] 	|| false) : false,
					fonts: 	v[2] ? (this.fonts[v[2] - 1] 	|| false) : false,
				}
			} else {
				return {};
			}
		}
	},

	mounted() {
		var clipboard = new ClipboardJS('.copy-btn');
		clipboard.on('success', function(e) {
			alert("Скопировано");
		});
	},

	methods: {

		generate() {
			var selected_fonts = this.selectRandom(this.fonts);

			selected_fonts.forEach((f) => {
				fonts.add({
					[f]: true
				});
			});

			this.selected = {
				colors: this.predefined.colors || this.selectRandom(this.colors),
				fonts: this.predefined.fonts || selected_fonts,
				topic: this.predefined.topic || this.selectRandom(this.topics)
			};

			this.generated = true;
		},

		selectRandom(array) {
			return array[Math.floor(Math.random()*array.length)];
		}

	},

	head() {
		return {
			title: "Персональное задание для участника марафона",
			meta: [
				// hid is used as unique identifier. Do not use `vmid` for it as it will not work
				{
					hid: 'description',
					name: 'description',
					content: 'My custom description'
				}
			]
		}
	}
}
</script>

<style lang="scss">
@import "~/assets/scss/ui/button";

.task-builder {
	min-height: 100vh;
	background-color: $primary-light;
	display: flex;
	flex-direction: row;
	justify-content: center;
	align-items: center;
	padding: 60px 0px;
	@include xs {
		padding: 20px 0px;
	}
}

.task-card {
	background-color: white;
	border-radius: 8px;
	padding: 30px;
	box-shadow: 0px 5px 15px rgba(darken($primary, 50%), .04);
	margin: 30px 0px;
	width: 640px;
	max-width: 90vw;
	&__title {
		font-weight: 700;
		font-size: 12px;
		opacity: .8;
		text-transform: uppercase;
		letter-spacing: 0.1em;
	}
	&__subtitle {
		margin-bottom: 20px;
		font-size: 14px;
		margin-top: 5px;
		opacity: .7;
		line-height: 1.4;
	}


	&__font {
    	border: 1px solid #ddd;
		display: inline-block;
		width: 50%;
		vertical-align: top;
		height: 160px;
		padding: 16px 25px 20px;
		margin-left: -1px;
		@include xs {
			width: 100%;
			margin-left: 0;
			margin-top: -1px;
		}
		&__letters {
			font-size: 50px;
			line-height: 1;
			height: 50px;
			margin-bottom: 8px;
		}

		&__name {
			font-weight: 600;
			font-size: 16px;
			white-space: nowrap;
			overflow: hidden;
			text-overflow: ellipsis;
		}

		&__type {
			font-size: 14px;
			opacity: .5;
			margin-top: 5px;
			margin-bottom: 5px;
		}

		a {
			color: $primary;
			text-decoration: none;
			font-size: 14px;
			font-weight: 600;
		}
	}

	&__topic {
		border-top: 1px solid #ddd;
		margin: 30px -30px 0px;
		padding: 30px 30px 0px 80px;
		.emoji {
			font-size: 35px;
			position: absolute;
			left: 30px;
			top: 28px;
			width: 35px;
			img {
				margin-top: 5px;
			}
		}
		&__title {
			font-size: 18px;
    		font-weight: 700;
		}
		&__text {
			font-size: 14px;
			line-height: 1.6;
			margin: 5px 0px 15px;
		}
		&__link {
			color: $primary;
			text-decoration: none;
			font-size: 14px;
			font-weight: 600;
			margin-right: 20px;
			display: inline-block;
		}
	}

	&__colors {
		display: flex;
		flex-direction: row;
		@include xs {
			display: block;
		}
		button {
			outline: none;
			border: 0px;
			box-shadow: 0px;
			appearance: none;
			display: block;
			width: 20%;
			height: 100px;
			border-radius: 4px;
			margin-bottom: 20px;
			cursor: pointer;
			@include xs {
				width: 100%;
				height: 50px;
				margin-bottom: 0;
			}
			+ button {
				margin-left: 8px;
				@include xs {
					margin-top: 6px;
					margin-left: 0;

				}
			}

			&::before {
				content: "Копировать";
				position: absolute;
				background-color: rgba(0,0,0,.5);
				color: white;
				text-transform: uppercase;
				left: 50%;
				top: 50%;
				transform: translate(-50%, -50%);
				padding: 8px;
				border-radius: 4px;
				font-size: 10px;
				font-weight: 600;
				letter-spacing: 0.1em;
				display: none;
				@include xs {
					z-index: 15;
					background-color: white;
					color: black;
				}
			}

			&:hover::before {
				display: block;
			}

			span {
				position: absolute;
				bottom: -20px;
				left: 0;
				width: 100%;
				text-align: center;
				@include xs {
					width: 80px;
					height: 20px;
					line-height: 20px;
					border-radius: 4px;
					background-color: rgba(255,255,255,.8);
					left: 50%;
					bottom: 50%;
					margin: 0px 0px -10px -40px;
					z-index: 10;
				}
			}
		}
	}
}
</style>
